import { Controller, Get, Res, Session } from '@nestjs/common';
import { Response } from 'express';
import { SessionData } from 'express-session';
import { AppService } from './app.service';

@Controller()
export class AppController {
  constructor(private readonly appService: AppService) {}

  @Get()
  getHello(
    @Session() session: SessionData,
    @Res() res: Response,
  ): Record<string, any> {
    if (!session.user) {
      res.redirect('/login');
      return;
    }

    res.render('index', { user: session.user });
  }
}
