import {
  MiddlewareConsumer,
  Module,
  NestModule,
  RequestMethod,
} from '@nestjs/common';
import { ValidateCSRFMiddleware } from 'src/middleware/validate-csrf.middleware';
import { UserModule } from 'src/modules/objects/user/user.module';
import { LoginController } from './login.controller';

@Module({
  imports: [UserModule],
  controllers: [LoginController],
})
export class LoginModule implements NestModule {
  configure(consumer: MiddlewareConsumer) {
    consumer
      .apply(ValidateCSRFMiddleware)
      .forRoutes({ path: '*', method: RequestMethod.POST });
  }
}
